#include<bits/stdc++.h>

using namespace std;
#define int long long

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    set<pair<int, int>> s;
    for (int i = 0; i < n; ++i) cin >> a[i];
    if(k == 1){
        int ans = 0;
        for(int i =0 ; i < n; ++i) ans = max(ans,a[i] + i + 1);
        cout << ans << '\n';
        return 0;
    }
    int mx = a[0];
    int y = 0;
    for (int i = 0; i < k - 1; ++i) {
        s.insert({a[i], i});
        y += a[i];
    }
    int ans = 0;

    for (int i = k - 1; i < n; ++i) {
        ans = max(ans, y + a[i] + i + 1);
        if (a[i] > s.begin()->first) {
            y -= s.begin()->first;
            y += a[i];
            s.erase(*s.begin());
            s.insert({a[i], i});
        }
    }
    cout << ans << '\n';
    return 0;
}
